<?php

//---------------------------------------------
//load carousel default settings from file
//---------------------------------------------
        
if (file_exists('carousel/3dcarousel.xml'))
{
    $xml = simplexml_load_file('carousel/3dcarouselv1.xml');
}
else
{
    die('settings file is missing');
}

// changing default settings is easy
$xml->Images['CarouselSpeed'] = 10;

//---------------------------------------------
//hardcoded sample entries
//---------------------------------------------

// load 9 images
for ($i = 1; $i <= 9; $i++) {      
  $image[$i] = Array(
    'Visible'             =>    'true',
    'ImagePath' 			    =>		'carousel/images/img'. (($i < 10) ? '0'.$i : $i) .'.jpg',
    'ImageLink'				    =>		'',
    'ImageLinkTarget'     =>		'',
    'ToolTip'				      =>    'Picture '.$i,
    'Content1'				    =>		'Content1 - Picture'.$i.' Click image to return!',
    'Content2'				    =>		'Content2 - Picture'.$i
    );
}
      
// static content 1
$static[0] = Array(
  'Attributes'  =>  Array(
          'HTML'          =>  'false',
          'AntiAliasing'  =>  'false',
          'Align'         =>  'left',
          'Bold'          =>  'false',
          'Font'          =>  'Verdana',
          'FontColor'     =>  '#000000',
          'FontSize'      =>  '11',
          'Leading'       =>  '0',
          'Underline'     =>  'false',
          'Left'          =>  '260',
          'Top'           =>  '10',
          'Width'         =>  '120',
          'Height'        =>  '45',
          'TopMost'       =>  'true',
          'BgColor'       =>  '#eeeeee',
          'Border'        =>  'true',
          'BorderColor'   =>  '#ff0000',
          'VisibleOnAnimationPage'   =>  'true',
          'VisibleOnDetailPage' =>  'true'
      ),
  'Content'     =>  'Content3 (static)'
  );
      
// static content 2
$static[1] = Array(
  'Attributes'  =>  Array(
          'HTML'          =>  'false',
          'AntiAliasing'  =>  'false',
          'Align'         =>  'left',
          'Bold'          =>  'false',
          'Font'          =>  'Verdana',
          'FontColor'     =>  '#000000',
          'FontSize'      =>  '11',
          'Leading'       =>  '0',
          'Underline'     =>  'false',
          'Left'          =>  '390',
          'Top'           =>  '10',
          'Width'         =>  '120',
          'Height'        =>  '45',
          'TopMost'       =>  'false',
          'BgColor'       =>  '#eeeeee',
          'Border'        =>  'true',
          'BorderColor'   =>  '#ff0000',
          'VisibleOnAnimationPage'   =>  'true',
          'VisibleOnDetailPage' =>  'true'
      ),
  'Content'     =>  'Content4 (static)'
  );

// hardcoded sample entries - END

foreach ($image as $entry)
{
	$tag = $xml->Images->addChild('Image');
	foreach ($entry as $key => $value)
	{
		$tag->addChild($key, '<![CDATA['.htmlentities($value).']]>');
	}
}

foreach ($static as $entry)
{
	$tag = $xml->StaticContents->addChild('StaticContent');
	
	foreach ($entry['Attributes'] as $a_key => $a_value)
	{
    $tag->addAttribute($a_key, $a_value);
	}
	
	$tag->addChild('Content', '<![CDATA['.htmlentities($entry['Content']).']]>');
}

print_r(html_entity_decode($xml->asXML()));

?>