<?php

//---------------------------------------------
// ADD YOUR SETTINGS AND AWS KEY HERE
//---------------------------------------------
define("ACCESS_KEY_ID", 'REPLACE_WITH_YOUR_ACCESS_KEY');
define('PATH_TO_CACHE', 'cache'); // path to cache WITHOUT trailing slash (can be relative)
define('URL_TO_CACHE', 'cache'); // url to cache WITHOUT trailing slash (can be relative)

//---------------------------------------------
//load gallery settings
//---------------------------------------------
    
if (file_exists('carousel/3dcarouselv1.xml'))
{
    $xml = simplexml_load_file('carousel/3dcarouselv1.xml');
}
else
{
    die('settings file is missing');
}

//---------------------------------------------
// prepare aws request
//---------------------------------------------

$Operation = "ItemSearch";
$Version = "2008-04-07";
$ResponseGroup = "Images,ItemAttributes,EditorialReview";
$SearchIndex = "Music";
$Keywords = urlencode($_GET['key']);

$request_default=
     "http://ecs.amazonaws.com/onca/xml"
   . "?Service=AWSECommerceService"
   . "&AWSAccessKeyId=" . ACCESS_KEY_ID
   . "&Operation=" . $Operation
   . "&Version=" . $Version
   . "&SearchIndex=" . $SearchIndex
   . "&Keywords=" . $Keywords
   . "&ResponseGroup=" . $ResponseGroup;

// create an empty array
$images = array();

// 1 page is enough
$max_page = 1;

// every request returns max 10 results
for ($page = 1; $page <= $max_page; $page++)
{

  $request = $request_default . "&ItemPage=" .$page;

  //---------------------------------------------
  // use cURL to send the request
  //---------------------------------------------

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $request);
  curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_HEADER, 0);
  $response = curl_exec($ch);
  curl_close($ch);

  //---------------------------------------------
  // response to xml / verify response
  //---------------------------------------------

  $parsed_xml = simplexml_load_string($response);
  if ($parsed_xml->Items->Request->IsValid != "True")
  {
      if (!empty($parsed_xml->Items->Request->Errors->Error))
      {
        foreach ($parsed_xml->Items->Request->Errors->Error as $error)
        {
            echo "Error code: " . $error->Code . "<br/>\n" . $error->Message;
        }
      } else {
       echo "No results. Did you submit a keyword?";
      }
      exit;
  }

  //---------------------------------------------
  // parse items
  //---------------------------------------------

  // get number of returned items
  $numOfItems = $parsed_xml->Items->TotalResults;

  // there are max 10 results per page
  if ($numOfItems < 10)
  { 
    $page = $max_page;
  }
    
  if ($numOfItems > 0)
  {
      for ($i = 0; $i < $numOfItems; $i++)
      {
        $current = $parsed_xml->Items->Item[$i];
        
        if (!isset($current->ImageSets->ImageSet->MediumImage->URL) || !isset($current->ImageSets->ImageSet->SmallImage->URL))
        {
            // skip item if there are no images
            continue;
        }
        
        // get medium image url
        $img_url_medium = $current->ImageSets->ImageSet->MediumImage->URL;  
        $img_md5_medium = md5($img_url_medium);
        download($img_url_medium, $img_md5_medium);
        
        // get small image url
        $img_url_small = $current->ImageSets->ImageSet->SmallImage->URL;  
        $img_md5_small = md5($img_url_small);
        download($img_url_small, $img_md5_small);
    
        if (isset($current->ItemAttributes->Title))
        {        
          $title = $current->ItemAttributes->Title;         
          if (strlen($title) > 20)
          {
            $title_split = split('[:-]', $title);
            $title_split = explode('[', $title_split[0]);
            $title = substr(trim($title_split[0]),0,19);
          }         
        }
        else
        {
          $title = 'Unknown Title';
        }
         
        $artist = (isset($current->ItemAttributes->Artist)) ? $current->ItemAttributes->Artist : 'Unknown Artist';   
        $number_of_discs = (isset($current->ItemAttributes->NumberOfDiscs)) ? $current->ItemAttributes->NumberOfDiscs : 'X';
    
        if (isset($current->EditorialReviews->EditorialReview->Content))
        {
          $review = $current->EditorialReviews->EditorialReview->Content;
          if (strlen($review) > 1000)
          {
            $review = trim(substr(strip_tags($review),0,1000))." ...";
          }
        }
        else
        {
          $review = 'Sorry. No review available.';
        }
        
        // create new item
        $item = array (
          'Visible'         =>    'true',
          'ImagePath' 			=>		URL_TO_CACHE.'/'.$img_md5_medium.'.jpg',
          'ImageLink'				=>		'',
          'ImageLinkTarget' =>		'_blank',
          'ToolTip'         =>    "<p align='left'><img src='".URL_TO_CACHE.'/'.$img_md5_small.'.jpg'."' align='left' width='50' height='50'><font size='14' color='#ffffff'><b>".substr($title,0,19)."</b></font><br><font color='#ffffff' size='12'>by ".substr($artist,0,23)."</font><br><font color='#EA820D' size='12'><b>Product Details:</b></font><br><font color='#ffffff' size='11'>Number of Discs: ".$number_of_discs."<br></font></p>",
          'Content1'				=>		"<font size='10' color='#cccccc'>Click image to return</font>",
          'Content2'				=>		"<a href='".$current->DetailPageURL."' target='_blank'><font size='16' color='#ffffff'><b>".$current->ItemAttributes->Title."</b></font></a><br><font color='#ffffff' size='11'>".$artist."</font><br><br><font color='#EA820D' size='13'><b>Product Details</b></font><br><font color='#ffffff' size='11'>".$current->ItemAttributes->Binding."<br>Number of Discs: ".$number_of_discs."<br>ASIN: ".$current->ASIN."<br></font><br><font color='#EA820D' size='13'><b>Editorial Reviews</b></font><br><font color='#ffffff' size='11'><b>Product Description:</b> ".$review."<br><a href='".$current->DetailPageURL."' target='_blank'><u>Read more ...</u></font></a>"
        );
        
        // add the item to the array
        array_push($images, $item);
      }
  }
}

//---------------------------------------------
//
//---------------------------------------------

foreach ($images as $entry)
{
	$tag = $xml->Images->addChild('Image');
	foreach ($entry as $key => $value)
	{
		$tag->addChild($key, '<![CDATA['.htmlentities($value).']]>');
	}
}

print_r(html_entity_decode($xml->asXML()));

function download($url, $md5)
{
        // we will cache the image on the server
        if (!file_exists(PATH_TO_CACHE.'/'.$md5.'.jpg'))
        {
            // store the image on the server (we will use the md5 hash as filename)
            $fp = fopen(PATH_TO_CACHE.'/'.$md5.'.jpg', 'w');
            
            // use cURL to get the image
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_FILE, $fp);
            curl_exec($ch);
            curl_close($ch);
            
            fclose($fp);
        }
}

?>